package extensions;

import java.io.IOException;

import java.net.Socket;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.Logger;
import dareka.extensions.Extension;
import dareka.extensions.RequestFilter;
import dareka.extensions.ExtensionManager;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.Resource;
import dareka.processor.StringResource;
import dareka.processor.Processor;
import dareka.processor.impl.Cache;

/*
 *
 */
public class liveInfoExtension implements Extension, Processor, RequestFilter {

	// Extension interface
	public Object queryInterface(Extension.Type type) {
		if (type == Extension.Type.Extension1)
			return (Extension) this;
		if (type == Extension.Type.Processor1)
			return (Processor) this;
		if (type == Extension.Type.RequestFilter1)
			return (RequestFilter) this;
		return null;
	}

	public void registerExtensions(ExtensionManager mgr) {
		mgr.registerProcessor(this);
		mgr.registerRequestFilter(this);
	}

	public String getVersionString() {
		return "liveInfoExtension (9).01+20121107mod";
	}

	public liveInfoExtension() throws IOException {
	}

	private static final String[] PROCESSOR_SUPPORTED_METHODS =
		new String[] { "GET" };

	public String[] getSupportedMethods() {
		return PROCESSOR_SUPPORTED_METHODS;
	}

	private static final Pattern PROCESSOR_SUPPORTED_PATTERN = Pattern.compile(
			"^http://live\\.nicovideo\\.jp/cache/liveinfo");

	private static final Pattern LIVE_PATTERN = Pattern.compile(
			"^http://.*\\.live\\.nicovideo\\.jp/api/getckey\\?(.+)");

	public Pattern getSupportedURLAsPattern() {
		return PROCESSOR_SUPPORTED_PATTERN;
	}

	public String getSupportedURLAsString() {
		return null;
	}

	private static String[] lvList = {"", ""};
	private static String[] idList = { "", "" };
	private static String[] idListIsCache = { "none", "none" };

	public int onRequest(HttpRequestHeader requestHeader) throws IOException {
		String uri = requestHeader.getURI();
		Matcher m = LIVE_PATTERN.matcher(uri);
		if (m.find()) {
			Pattern pattern1 = Pattern.compile("&");
			String[] splitStr1 = pattern1.split(m.group(1));
			for(int i=0; i<splitStr1.length;i++){
				Pattern pattern2 = Pattern.compile("=");
				String[] splitStr2 = pattern2.split(splitStr1[i]);
				if(splitStr2[0].equals("id")) {
					idList[1] = idList[0];
					idList[0] = splitStr2[1];
				}
				if(splitStr2[0].equals("referer%5Fid")) {
					lvList[1] = lvList[0];
					lvList[0] = splitStr2[1];
				}
				if(splitStr2[0].equals("referer_id")) {
					lvList[1] = lvList[0];
					lvList[0] = splitStr2[1];
				}
			}
			idListIsCache[1] = idListIsCache[0];
			String isCache = Cache.getType(idList[0]);
			if (isCache != null) {
				if (isCache.equals("")) {
					idListIsCache[0] = "cache";
				} else {
					idListIsCache[0] = "low";
				}
			} else {
				idListIsCache[0] = "none";
			}
		}
		return RequestFilter.OK;
	}

	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
		String str = lvList[0]+","+idList[0]+","+idListIsCache[0] + "," + lvList[1]+","+idList[1]+","+idListIsCache[1];
		StringResource r = new StringResource(str);
		r.addNoCacheResponseHeaders();
		r.addResponseHeader(HttpHeader.CONTENT_TYPE, "text/plain");
		return r;
	}

}


